function charexport_initialize()
  SlashCmdList["CHAREXPORT"] = charexport_command;
  SLASH_CHAREXPORT1 = "/ce";
  SLASH_CHAREXPORT2 = "/charexp";
end

function charexport_command()
  exportdata();
  ReloadUI();
  --DEFAULT_CHAT_FRAME:AddMessage("Daten wurden exportiert.",1,1,1);
end

function exportdata()
  if (not characters) then
    characters={};
  end
  if (not characters[UnitName("player")]) then
    characters[UnitName("player")]={};
  end
  characters[UnitName("player")]["Server"] =GetCVar("realmName");
  characters[UnitName("player")]["Name"]   =UnitName("player");
  characters[UnitName("player")]["Guild"]  ="";
  characters[UnitName("player")]["Guild"]  =GetGuildInfo("player");
  characters[UnitName("player")]["Race"]   =UnitRace("player");
  characters[UnitName("player")]["Class"]  =UnitClass("player");
  characters[UnitName("player")]["Gender"] =UnitSex("player");
  characters[UnitName("player")]["Level"]  =UnitLevel("player");
  characters[UnitName("player")]["Zone"]   =GetZoneText();
  characters[UnitName("player")]["Subzone"]=GetSubZoneText(0);
  characters[UnitName("player")]["Items"]  ={};
  for i=1,19 do
    local item=GetItemInfo(i);
    if(item)then
      characters[UnitName("player")]["Items"][i]=item;
    end
  end

  characters[UnitName("player")]["Resistances"]  ={};
  for i=0,6 do
    local res1,res2,res3,res4=UnitResistance("player",i);
    if(res1)then
      characters[UnitName("player")]["Resistances"][i]={};
      characters[UnitName("player")]["Resistances"][i][1]=res1;
      characters[UnitName("player")]["Resistances"][i][2]=res2;
      characters[UnitName("player")]["Resistances"][i][3]=res3;
      characters[UnitName("player")]["Resistances"][i][4]=res4;
    end
  end

  characters[UnitName("player")]["Stats"]  ={};
  for i=1,5 do
    local stat1,stat2,stat3,stat4=UnitStat("player",i);
    if(stat1)then
      characters[UnitName("player")]["Stats"][i]={};
      characters[UnitName("player")]["Stats"][i][1]=stat1;
      characters[UnitName("player")]["Stats"][i][2]=stat2;
      characters[UnitName("player")]["Stats"][i][3]=stat3;
      characters[UnitName("player")]["Stats"][i][4]=stat4;
    end
  end
  
  characters[UnitName("player")]["Skills"]={};
  for i=1,GetNumSkillLines() do
    local skillName, header, isExpanded, skillRank, numTempPoints, skillModifier, skillMaxRank, isAbandonable, stepCost, rankCost, minLevel, skillCostType = GetSkillLineInfo(i);
    characters[UnitName("player")]["Skills"][i]={skillName,skillRank,skillModifier,skillMaxRank};
    characters[UnitName("player")]["Skills"][i]["skillName"]=skillName;
    characters[UnitName("player")]["Skills"][i]["skillRank"]=skillRank;
    characters[UnitName("player")]["Skills"][i]["skillModifier"]=skillModifier;
    characters[UnitName("player")]["Skills"][i]["skillMaxRank"]=skillMaxRank;
  end

  characters[UnitName("player")]["Talents"]={};
  for i=1,GetNumTalentTabs() do
    characters[UnitName("player")]["Talents"]["Tab"..i]={};
    for t=1,GetNumTalents(i) do
      characters[UnitName("player")]["Talents"]["Tab"..i][t]={};
      local tName,tTexture,tPosX,tPosY,tSkill,tMaxSkill,tIsCastable,v8 = GetTalentInfo(i,t);
      if(not(tIsCastable))then
        tIsCastable=0
      end
      characters[UnitName("player")]["Talents"]["Tab"..i][t]["name"]=tName
      characters[UnitName("player")]["Talents"]["Tab"..i][t]["texture"]=tTexture
      characters[UnitName("player")]["Talents"]["Tab"..i][t]["posX"]=tPosX
      characters[UnitName("player")]["Talents"]["Tab"..i][t]["posY"]=tPosY
      characters[UnitName("player")]["Talents"]["Tab"..i][t]["skill"]=tSkill
      characters[UnitName("player")]["Talents"]["Tab"..i][t]["maxSkill"]=tMaxSkill
      characters[UnitName("player")]["Talents"]["Tab"..i][t]["isCastable"]=tIsCastable
    end
  end

end


function GetItemInfo(index)
  -- With some help from the Character Profiler (http://www.cethinchimera.com)
  itemlink=GetInventoryItemLink("player", index);
  if(itemlink)then
    local iteminfo = {};
    InvisibleTooltip:SetInventoryItem("player", index);
    iteminfo["texture"]=GetInventoryItemTexture("player",index);
    iteminfo["quality"]=GetInventoryItemQuality("player",index);
    iteminfo["position"]=index;

    maxline=30;
    for line = 1, 30 do
      left=false;
      right=false;
      lefttext="";
      righttext="";
      tooltiptext = getglobal("InvisibleTooltipTextLeft"..line);
      if(tooltiptext and tooltiptext:IsVisible() and tooltiptext:GetText() ~= nil) then
        lefttext=tooltiptext:GetText();
        left=true;
      end
      tooltiptext = getglobal("InvisibleTooltipTextRight"..line);
      if(tooltiptext and tooltiptext:IsVisible() and tooltiptext:GetText() ~= nil) then
        righttext=tooltiptext:GetText();
        right=true;
      end
      if(left or right)then
        iteminfo["tooltipLeft"..line]=lefttext;
        iteminfo["tooltipRight"..line]=righttext;
      else
        maxline=line-1;
        break;
      end
    end
    iteminfo["tooltipLines"]=maxline;

    return iteminfo;
  else
    return nil;
  end
end
